# include <iostream>
# include<cstdlib>
using namespace std;
 
class Passenger { 
private: 
    static int offlineCnt;
    static int searchingCnt;
    static int travelingCnt; 
    int id; 
    int status; //1: Offline  2:Searching   3:Traveling 
    int x; 
    int y; 
    int ratingCnt; 
    int* ratings;   
    int currentDriverID;
      
public:
    Passenger(int id){
        this->id=id;
        status=1;
        x=0;
        y=0;
        ratingCnt=0;
        ratings=new int[500];
        ratings[0]=3;   //default rating
        currentDriverID=0;
        Passenger::offlineCnt+=1;
    }
         
    void searchFail(int x, int y){
        this->x=x;
        this->y=y;
    }
     
    void searchFound(int x, int y,int driverID){
        this->x=x;
        this->y=y;
        status=3;
        currentDriverID=driverID;
        Passenger::offlineCnt-=1;
        Passenger::travelingCnt+=1;
    }
     
    int arrive(int x, int y, int rate){
        this->x=x;
        this->y=y;
        ratingCnt+=1;
        ratings[ratingCnt]=rate;
        status=1;
        Passenger::offlineCnt+=1;
        Passenger::travelingCnt-=1;
        return currentDriverID;         
    }
     
    bool goodPass(){			//if passenger has good rating score
        int sumRate=0;
        for(int i=1;i<= ratingCnt ; i++){
            sumRate+=ratings[i];
        }
        if(sumRate>=ratingCnt*2){
            return true;
        }else{
            return false;
        }        
    }
     
    static int getPassSum(){
        return Passenger::offlineCnt+Passenger::searchingCnt+Passenger::travelingCnt; 
    }
      
    bool passEqual(int passID){
        if(passID==id){
            return true;
        }       
        return false;
    }
     
};
int Passenger::offlineCnt = 0;  //initialize to 0
int Passenger::searchingCnt = 0;    //initialize to 0
int Passenger::travelingCnt = 0;    //initialize to 0
 
class Driver { 
private: 
    static int offlineCnt;
    static int searchingCnt; 
    static int travelingCnt; 
    int id;         //id=0 is not vaild
    int status;     //1: Offline  2:Searching   3:Traveling 
    int x; 
    int y; 
    int ratingCnt; 
    int* ratings;
	int revenue; 
     
public: 
    Driver(){
        id=0;   
        status=1;
        x=0;
        y=0;
        ratingCnt=0;
        ratings=new int[500];   
        ratings[0]=3;
        revenue=0;
    }
     
    Driver(int id){
        this->id=id;    
        status=1;
        x=0;
        y=0;
        ratingCnt=0;
        ratings=new int[500];   
        ratings[0]=3;
        revenue=0;
        Driver::offlineCnt+=1;  
    }
     
     
    void openApp(int x, int y){
        this->x=x;
        this->y=y;
        status=2;
        Driver::offlineCnt-=1;
        Driver::searchingCnt+=1;  
    }
     
    void closeApp(){
        status=1;
        Driver::offlineCnt+=1;
        Driver::searchingCnt-=1; 
    }
     
    void assigned(int x,int y){
        this->x=x;
        this->y=y;
        status=3;
        Driver::travelingCnt+=1;
        Driver::searchingCnt-=1;
    }
     
    void arrive(int x, int y, int rate,int A,int a,int b){
    	int d=abs(this->x - x)+abs(this->y - y);
		if(d<=A){
			revenue+=a;
		}else{
			revenue+= (a + b*(d-A));
		}
    	
        this->x=x;
        this->y=y;
        ratingCnt+=1;
        ratings[ratingCnt]=rate;
        status=2;
        Driver::searchingCnt+=1;
        Driver::travelingCnt-=1;
    }
     
    bool isAvailable(int xPass,int yPass, int m){
        if(abs(x-xPass)+abs(y-yPass)<=m &&status==2){
            return true; 
        }else{
            return false;
        }       
    }
     
    bool isSearching(){
        if(status==2){      
            return true;
        }
        return false;
    }
     
    static int getDriverSum(){
        int sum= Driver::offlineCnt+Driver::searchingCnt+Driver::travelingCnt;
        return sum;
    }
     
    static int getDriverSearching(){
        return Driver::searchingCnt;
    }
     
    int getDriverID(){
        return id;
    }
     
    bool driverEqual(int driverID){
        if(driverID==id){
            return true;
        }       
        return false;
    }
     
    int getRevenue(){
		return revenue;
	}
	 
    bool operator> ( const Driver & that) const; 
      
    void printDrive(){
        cout<<id;
    } 
}; 
int Driver::offlineCnt = 0; //initialize to 0
int Driver::searchingCnt = 0;   //initialize to 0
int Driver::travelingCnt = 0;   //initialize to 0
 
 
bool Driver::operator> ( const Driver& that) const{
    int scoreThis=0;
    int scoreThat=0;
    if(that.id==0){     //best٨SH 
        return true;
    }
      
      
    if(this->ratingCnt==0 && that.ratingCnt==0){
        scoreThis=this->ratings[this->ratingCnt];   //it's actually 3 in this problem
        scoreThat=that.ratings[that.ratingCnt];

    }else if(this->ratingCnt==0){
        int sumRateThat=0;
        for(int i=1;i<=that.ratingCnt;i++){
            sumRateThat+=that.ratings[i];
        }
          
        scoreThis=(this->ratings[this->ratingCnt])*that.ratingCnt;
        scoreThat=sumRateThat;
          
          
    }else if(that.ratingCnt==0){     
        int sumRateThis=0;
          
        for(int i=1;i<= this->ratingCnt ; i++){
            sumRateThis+=this->ratings[i];
        }
        scoreThis=sumRateThis;
        scoreThat=that.ratings[that.ratingCnt]*(this->ratingCnt);
                    
    }else{
        int sumRateThis=0;
        int sumRateThat=0;
        for(int i=1;i<=that.ratingCnt;i++){
            sumRateThat+=that.ratings[i];
        }
        for(int i=1;i<= this->ratingCnt ; i++){
            sumRateThis+=this->ratings[i];
        }
        scoreThis=sumRateThis*(that.ratingCnt);		//eۭ 
        scoreThat=sumRateThat*(this->ratingCnt);	//eۭ
          
    }
      
    //compare
      
    if(scoreThis>scoreThat){
        return true;
    }else if(scoreThis==scoreThat){
        if(this->id < that.id){
            return true;
        }
    }
    return false;
 
}
 
 
int findBestDriver(int passID,int x, int y,int m,Driver** driver){  
     
    int mStart=m;
    int searchingDriver=Driver::getDriverSearching();
        
    int availCount=0;//ӽSavail 
    if(searchingDriver==0){
        return 0;
    }
    Driver* bestDriver=new Driver;
     
    while(searchingDriver>0 &&availCount < 1){
        availCount=0;
        for(int i=1;i<=Driver::getDriverSum();i++){
            if(driver[i]->isAvailable(x,y,m)){
                availCount+=1;
                if(*driver[i] > *bestDriver){
                    bestDriver= driver[i];
                }               
            }   
        }
             
        m=mStart+m;        
    }
     
    return bestDriver->getDriverID();     
}

int passInList(int passID,Passenger** pass){
    for(int i=1;i<=Passenger::getPassSum();i++){
        if(pass[i]->passEqual(passID)){
            return i;
        }
    }     
    return 0;
}
 
int driverInList(int driverID,Driver** driver){
    for(int i=1;i<=Driver::getDriverSum();i++){
        if(driver[i]->driverEqual(driverID)){
            return i;
        }
    }    
    return 0;
}
 
 
int main(){
	int A,a,b;
	cin>>A>>a>>b;

    Passenger* pass[100000]; 
    Driver* driver[100000];     
     
    int m;
    cin>>m;
     
    char event;
     
    while(cin>>event){
        if(event=='P'){
            int passID;
            cin>>passID;
            pass[Passenger::getPassSum()]=new Passenger(passID);
             
        }else if(event=='D'){
            int driverID;
            cin>>driverID;
            driver[Driver::getDriverSum()]=new Driver(driverID);
             
        }else if(event=='O'){
            int driverID, x, y;
            cin>>driverID>>x>>y;
             
            int driverListID=driverInList(driverID,driver);
            if(driverListID==0){        //no this driver
                cout<<"Error: driverID is not exist."<<endl;
                continue;
            }
			       
            driver[driverListID]->openApp(x,y);
             
        }else if(event=='S'){
            int passID,x,y;
            cin>>passID>>x>>y;
             
             
            int passListID=passInList(passID,pass);
            if(passListID==0){      //no this passeenger
                cout<<"Error: PassID is not exist."<<endl;
                continue;
            }
             
            if(pass[passListID]->goodPass()){       //chech pass have enough rate 
                int found=findBestDriver(passListID,x,y,m,driver);  //  find highest rate and available driver:
                if(found){
                    pass[passListID]->searchFound(x,y,found);                     
                    int driverListID=driverInList(found,driver);                     
                    driver[driverListID]->assigned(x,y);
                }else{
                    pass[passListID]->searchFail(x,y);
                }
            }else{	//not a good pass
                pass[passListID]->searchFail(x,y);  
            }
             
         
        }else if(event=='A'){
            int passID,x,y,rP,rD;
            cin>>passID>>x>>y>>rP>>rD;
             
            int passListID=passInList(passID,pass);
            if(passListID==0){      //no this passeenger
                continue;
            }
             
            int driverListID=driverInList(pass[passListID]->arrive(x,y,rD),driver);
            driver[driverListID]->arrive(x,y,rP,A,a,b);
             
        }else if(event=='C'){
            int driverID;
            cin>>driverID;
             
            int driverListID=driverInList(driverID,driver);
             
            driver[driverListID]->closeApp();
        }
             
    }
     
     
	//output
	
	for(int i=1;i<Driver::getDriverSum();i++){
		cout<<driver[i]->getRevenue()<<" ";
	}
	cout<<driver[Driver::getDriverSum()]->getRevenue()<<endl;
	
	
	return 0;
}





